## sasl-xoauth2 0.20

=== CMakeLists.txt ===
# Copyright 2020 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_minimum_required(VERSION 3.0.0)
cmake_policy(VERSION 3.0)

execute_process(
  COMMAND head -n 1 ChangeLog
  COMMAND sed -e "s/.*(//" -e "s/).*//"
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  OUTPUT_VARIABLE CHANGELOG_VERSION
  OUTPUT_STRIP_TRAILING_WHITESPACE)

project(sasl-xoauth2 VERSION ${CHANGELOG_VERSION} LANGUAGES CXX)

include(GNUInstallDirs)

option(EnableTests "Enable tests." ON)

if(EnableTests)
  enable_testing()
endif()
add_subdirectory(docs)
add_subdirectory(scripts)
add_subdirectory(src)

set(CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${PROJECT_VERSION}")
set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_IGNORE_FILES "/build/;/packaging/;/packaging-build/;/packaging-output/;/packaging-scripts/;/.git/;/.gitignore;.clang-format;~$;${CPACK_SOURCE_IGNORE_FILES}")

include(CPack)

=== docs/CMakeLists.txt ===
set(MD_TO_MAN
  sasl-xoauth2.conf.5)

find_program(PANDOC_PATH NAMES pandoc DOC "Path to pandoc, for Markdown-to-man-page conversion")
if(NOT EXISTS ${PANDOC_PATH})
  message(FATAL_ERROR "Unable to find pandoc")
else()
  message(STATUS "Found pandoc: ${PANDOC_PATH}")
endif()

foreach(man_page IN LISTS MD_TO_MAN)
  set(src ${CMAKE_CURRENT_SOURCE_DIR}/${man_page}.md)
  set(dst ${CMAKE_CURRENT_BINARY_DIR}/${man_page})

  if(NOT EXISTS "${src}")
    message(FATAL_ERROR "Unable to find Markdown at ${src} for ${man_page}")
  endif()

  if(man_page MATCHES "\\.([0-9])$")
    set(man_num ${CMAKE_MATCH_1})
  else()
    message(FATAL_ERROR "No man number in ${man_page}")
  endif()

  add_custom_command(
    OUTPUT ${dst}
    COMMAND ${PANDOC_PATH} -s -t man "${src}" -o "${dst}"
    DEPENDS ${src}
    COMMENT "Generating ${man_page}"
    VERBATIM)

  add_custom_target("${man_page}_man" ALL DEPENDS ${dst})
  install(
    FILES ${dst}
    DESTINATION "${CMAKE_INSTALL_FULL_MANDIR}/man${man_num}"
    COMPONENT doc)
endforeach()

=== scripts/CMakeLists.txt ===
# Copyright 2020 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set(SCRIPTS
  sasl-xoauth2-tool)

find_program(ARGPARSE_MANPAGE_PATH NAMES argparse-manpage DOC "Path to argparse-manpage, to generate man pages from Python scripts")
if(NOT EXISTS ${ARGPARSE_MANPAGE_PATH})
  message(FATAL_ERROR "Unable to find argparse-manpage")
else()
  message(STATUS "Found argparse-manpage: ${ARGPARSE_MANPAGE_PATH}")
endif()

foreach(script IN LISTS SCRIPTS)
  set(man_num 1)

  set(src ${CMAKE_CURRENT_SOURCE_DIR}/${script}.in)
  set(dst ${CMAKE_CURRENT_BINARY_DIR}/${script})
  set(man_base ${script}.${man_num})
  set(man ${CMAKE_CURRENT_BINARY_DIR}/${man_base})

  if(NOT EXISTS "${src}")
    message(FATAL_ERROR "Unable to find template at ${src} for ${script}")
  endif()

  configure_file(${src} ${dst})

  add_custom_command(
    OUTPUT ${man}
    COMMAND ${ARGPARSE_MANPAGE_PATH} --pyfile "${dst}" --function "argparse_get_parser" --author "Tarick Bedeir" --author-email "tarick@bedeir.com" --project-name "sasl-xoauth2" --url "https://github.com/tarickb/sasl-xoauth2" > "${man}"
    DEPENDS ${dst}
    COMMENT "Generating man page for ${script}"
    VERBATIM)

  install(
    PROGRAMS ${dst}
    DESTINATION ${CMAKE_INSTALL_BINDIR}
    COMPONENT scripts)

  add_custom_target("${man_base}_man" ALL DEPENDS ${man})
  install(
    FILES ${man}
    DESTINATION "${CMAKE_INSTALL_FULL_MANDIR}/man${man_num}"
    COMPONENT doc)
endforeach()

=== src/CMakeLists.txt ===
# Copyright 2020 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -g -Wall -Werror")

find_package(PkgConfig REQUIRED)
find_package(CURL REQUIRED)

pkg_check_modules(JSON REQUIRED "jsoncpp")
pkg_check_modules(SASL REQUIRED "libsasl2")

include_directories(${CMAKE_SOURCE_DIR}/src)

set(SOURCES
  client.cc
  client.h
  config.cc
  config.h
  http.cc
  http.h
  log.cc
  log.h
  module.cc
  module.h
  token_store.cc
  token_store.h)

set(TEST_CONFIG_SOURCES
  test_config.cc)

set(CONFIG_FILE ${PROJECT_NAME}.conf)
set(CONFIG_FILE_FULL_PATH ${CMAKE_INSTALL_FULL_SYSCONFDIR}/${CONFIG_FILE})

link_directories(${JSON_LIBRARY_DIRS})

add_library(${PROJECT_NAME} SHARED ${SOURCES} ${CONFIG_FILE})
target_include_directories(${PROJECT_NAME} SYSTEM PUBLIC ${CURL_INCLUDE_DIRS} ${SASL_INCLUDE_DIRS} ${JSON_INCLUDE_DIRS})
target_link_libraries(${PROJECT_NAME} ${CURL_LIBRARIES} ${JSON_LIBRARIES})
target_compile_definitions(${PROJECT_NAME} PRIVATE CONFIG_FILE_FULL_PATH="${CONFIG_FILE_FULL_PATH}")

add_library(${PROJECT_NAME}-static STATIC ${SOURCES} ${CONFIG_FILE})
target_include_directories(${PROJECT_NAME}-static SYSTEM PUBLIC ${CURL_INCLUDE_DIRS} ${SASL_INCLUDE_DIRS} ${JSON_INCLUDE_DIRS})
target_link_libraries(${PROJECT_NAME}-static ${CURL_LIBRARIES} ${JSON_LIBRARIES})
target_compile_definitions(${PROJECT_NAME}-static PRIVATE CONFIG_FILE_FULL_PATH="${CONFIG_FILE_FULL_PATH}")

add_executable(test-config ${TEST_CONFIG_SOURCES} ${CONFIG_FILE})
target_include_directories(test-config SYSTEM PUBLIC ${CURL_INCLUDE_DIRS} ${SASL_INCLUDE_DIRS} ${JSON_INCLUDE_DIRS})
target_link_libraries(test-config ${PROJECT_NAME}-static ${CURL_LIBRARIES} ${JSON_LIBRARIES})
target_compile_definitions(test-config PRIVATE CONFIG_FILE_FULL_PATH="${CONFIG_FILE_FULL_PATH}")

install(
  TARGETS ${PROJECT_NAME}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/sasl2)

install(
  TARGETS test-config
  RUNTIME DESTINATION ${CMAKE_INSTALL_LIBDIR}/${PROJECT_NAME})

install(
  FILES ${CONFIG_FILE}
  DESTINATION ${CMAKE_INSTALL_SYSCONFDIR}
  COMPONENT config)

add_executable(${PROJECT_NAME}_test xoauth2_test.cc)
target_link_libraries(${PROJECT_NAME}_test ${PROJECT_NAME})

add_test(
  NAME ${PROJECT_NAME}_test
  COMMAND ${PROJECT_NAME}_test)

=== debian/changelog ===
sasl-xoauth2 (0.20-1) experimental; urgency=medium

  * new upstream version
  * work around argparse-manpage bug (Closes: #1034065)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Tue, 30 May 2023 17:30:18 -0400

sasl-xoauth2 (0.19-2) experimental; urgency=medium

  * wrap-and-sort -ast
  * ship sasl-xoauth2.conf as an example, not as a conffile

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 03 Mar 2023 11:47:29 -0500

sasl-xoauth2 (0.19-1) experimental; urgency=low

  * Package for Debian (Closes: #1006888)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 23 Feb 2023 18:48:25 -0500

=== debian/control ===
Source: sasl-xoauth2
Section: utils
Priority: optional
Maintainer: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dh-sequence-bash-completion,
 libcurl4-gnutls-dev,
 libjsoncpp-dev,
 libsasl2-dev,
 pandoc,
 pkg-config,
 python3-argcomplete,
 python3-argparse-manpage,
 python3-setuptools,
Standards-Version: 4.6.2
Homepage: https://github.com/tarickb/sasl-xoauth2
Rules-Requires-Root: no

Package: sasl-xoauth2
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 sasl-xoauth2-tool,
Description: SASL extension for XOAUTH2
 This SASL plugin enables client-side use of OAuth 2.0. Among other
 things it enables the use of Gmail or Outlook/Office 365 SMTP relays
 from Postfix.
 .
 It should be configured using data manipulated by the
 sasl-xoauth2-tool package.

Package: sasl-xoauth2-tool
Architecture: any
Recommends:
 python3-argcomplete,
 sasl-xoauth2,
Depends:
 python3,
 ${misc:Depends},
 ${shlibs:Depends},
Description: Tool for maintaining SASL XOAUTH2 connections
 This package contains a tool for configuring and administering an XOAUTH2
 linkage via SASL.
 .
 This is typically used to configure the sasl-xoauth2 package.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

execute_after_dh_auto_build:
	mkdir -p completions manpages
	register-python-argcomplete --shell bash sasl-xoauth2-tool > completions/sasl-xoauth2-tool
	argparse-manpage --pyfile $(wildcard obj*/scripts/sasl-xoauth2-tool) --object parser \
		--author 'Tarick Bedeir' --author-email 'tarick@bedeir.com' --project-name sasl-xoauth2 \
		--url https://github.com/tarickb/sasl-xoauth2 --output manpages/sasl-xoauth2-tool.1

=== debian/watch ===
version=4
opts=mode=git \
https://github.com/tarickb/sasl-xoauth2.git \
refs/tags/release-@ANY_VERSION@
